﻿using Mirea.Api.Dto.Common;
using System;

namespace Mirea.Api.Dto.Responses;

/// <summary>
/// Represents the response containing information about available OAuth providers.
/// </summary>
public class AvailableProvidersResponse
{
    /// <summary>
    /// Gets or sets the name of the OAuth provider.
    /// </summary>
    public required string ProviderName { get; set; }

    /// <summary>
    /// Gets or sets the enum value representing the OAuth provider.
    /// </summary>
    public OAuthProvider Provider { get; set; }

    /// <summary>
    /// Gets or sets the redirect URI for the OAuth provider.
    /// </summary>
    public required Uri Redirect { get; set; }
}